<?php
if(!class_exists("Gc_Message_Box_Admin_Renderer")){
	class Gc_Message_Box_Admin_Renderer extends Gc_Abstract_Renderer{
        protected $options;
        protected $themes_repo;

        public function __construct($namespace, $controller,$options){
            parent::__construct($namespace,$controller);
            $this->options = $options;
            $this->themes_repo = Gc_Theme_Repository_Factory::get_instance();
    	}

    	public function render($gci) {
            global $GC_Message_Box_Config;
            ?>
            <div id="gc_message_box_admin">
                <h2>GC Message Box</h2>
                <div class="wrap">
                    <div class="mainmessage">
                        Have questions or wanna suggest an idea? Visit the <a href="<?php echo $GC_Message_Box_Config['GCHOME']; ?>/forum?f=23&utm_source=gc_message_box_text&utm_medium=top_message&utm_campaign=discuss_forum" target="_blank">GC Message Box forum</a>
                    </div>
                    <form method="post" id="updateSettings">
                    <?php $this->render_general_settings(); ?>
                    <div class="submit">
                        <input name="Submit_gc_message_box" type="submit" class="button-primary" value="Save Changes" />
                    </div>
                    <?php $this->render_style_settings(); ?>
                    <div class="submit bottom">
                        <input name="Submit_gc_message_box" type="submit" class="button-primary" value="Save Changes" />
                    </div>
                    <div class="copy">GC Message Box plugin for WordPress by <a class="gcmblink" href="<?php echo $GC_Message_Box_Config['GCHOME']; ?>/?utm_source=gc_message_box_text&utm_medium=copy_message&utm_campaign=home" target="_blank">GetConversion</a><br />Current version: <?php echo get_message_box_version(); ?></div>
                    </form>
                </div>
                <div id="gc_ad">
                    <iframe id="gc_message_box_banners" src="<?php echo $GC_Message_Box_Config['GCHOME'].$GC_Message_Box_Config['GCSERVICES'].'/gcmessageboxad';?>"></iframe>
                </div>
                <div class="clear"></div>
            </div>
            <?php
    	}

        protected function render_style_settings() {
            wp_nonce_field( 'admin_init' );
            do_settings_sections( 'style_options' );
            settings_fields( 'style_options' ); ?>
            <div id="style-elements" class="<?php echo $this->namespace;?>admin">
                <table class="form-table">
                    <tbody>
                        <?php 
                            $options = $this->get_style_options();
                            foreach($options as $id => $option) {
                        ?>
                        <tr id="<?php echo $id; ?>_row">
                            <th scope="row" style="text-align: right; vertical-align: top;">
                                <?php echo __($option->get_text()); ?>
                            </th>
                            <td>
                                <?php if($option->is_color()) { 
                                    $this->render_color_option($option);
                                } 
                                if ($option->is_checkbox()) {
                                    $this->render_checkbox_option($option);
                                }
                                if ($option->is_radio()) {
                                    $this->render_radio($option);
                                }
                                if ($option->is_number()) {
                                    $this->render_number_option($option);
                                }
                                ?>
                            </td>
                        </tr>
                        <? } ?>
                    </tbody>
                </table><div class="clear"></div>
            </div><?
        }

        protected function render_general_settings() {
            wp_nonce_field( 'update-options' );
            do_settings_sections( 'general_options' );
            settings_fields( 'general_settings' ); ?>
            <div id="general-elements" class="<?php echo $this->namespace;?>admin">
                <table class="form-table">
                    <tbody>
                        <?php 
                            $options = $this->get_general_options();
                            foreach($options as $id => $option) {
                        ?>
                        <tr id="<?php echo $id; ?>_row">
                            <th scope="row" style="text-align: right; vertical-align: top;"><?php echo __($option->get_text()); ?></th>
                            <td>
                                <?php if($option->is_text()) { 
                                    $this->render_text($option);
                                } 
                                if ($option->is_checkbox()) {
                                    $this->render_checkbox($option);
                                }
                                if ($option->is_text_area()) {
                                    $this->render_text_area($option);
                                }
                                if ($option->is_select()) {
                                    $this->render_select($option);
                                }
                                if ($option->is_radio()) {
                                    $this->render_radio($option);
                                }
                                if ($option->is_number()) {
                                    $this->render_number_option($option);
                                }
                                 ?>
                            </td>
                        </tr>
                        <?php } ?>
                        <tr>
                            <th scope="row" style="text-align: right; vertical-align: top;"><?php echo __('Predefined Color Sets:') ?></th>
                            <td>
                                <?php $this->render_theme_selector(); ?>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <input type="hidden" name="hidden" />
            </div>
            <script type="text/javascript" src="<?php echo get_bloginfo('wpurl'); ?>/wp-admin/js/farbtastic.js"></script>
            <script type="text/javascript">
                var GC = {};
                GC.MessageBox = {
                    sets : {<?php $this->render_js_theme_sets(); ?>},
                    current : {<?php $this->render_js_current_theme(); ?>},
                    colorPickerSetup : function () {
                        <?php
                        $colors = $this->options->filter_options_by_type("color");
                        foreach($colors as $key => $color) : ?>
                        jQuery('#<?php echo $color->get_name(); ?>_cp').hide();
                        jQuery('#<?php echo $color->get_name(); ?>_cp').farbtastic("#<?php echo $color->get_name(); ?>");
                        jQuery("#<?php echo $color->get_name(); ?>").click(function(){
                            jQuery(".colorpickers:not([id=\"<?php echo $color->get_name(); ?>_cp\"])").slideUp('medium');
                            jQuery('#<?php echo $color->get_name(); ?>_cp').slideToggle('medium');
                        });
                        <?php endforeach; ?>    
                    },
                    trigger : function () {
                        //Predefined colors change
                        GC.MessageBox.changeColors(GC.MessageBox.current);
                        jQuery("#<?php echo $this->namespace; ?>predefined").change(function() {
                            GC.MessageBox.changeColors(GC.MessageBox.sets[jQuery("#<?php echo $this->namespace; ?>predefined option:selected").val()]);
                        });
                        
                        //Enable repeat hiding
                        if (jQuery("#<?php echo $this->namespace; ?>enable_repeat").is(':checked')) {
                            jQuery("#repeat_after_row").show();
                        } else {
                            jQuery("#repeat_after_row").hide();
                        }
                        jQuery("#<?php echo $this->namespace; ?>enable_repeat").change(function() {
                            if (jQuery("#<?php echo $this->namespace; ?>enable_repeat").is(':checked')) {
                                jQuery("#repeat_after_row").show();
                            } else {
                                jQuery("#repeat_after_row").hide();
                            }
                        });
                        
                        //Appear here hiding
                        if (jQuery("#<?php echo $this->namespace; ?>appear_here_1:checked").val() === "1") {
                            jQuery("#appear_here_home_row").hide();
                            jQuery("#appear_here_category_row").hide();
                            jQuery("#appear_here_tag_row").hide();
                            jQuery("#appear_here_archive_row").hide();
                            jQuery("#appear_here_author_row").hide();
                            jQuery("#appear_here_search_row").hide();
                            jQuery("#appear_here_pages_row").hide();
                            jQuery("#appear_here_article_row").hide();
                        } else {
                            jQuery("#appear_here_home_row").show();
                            jQuery("#appear_here_category_row").show();
                            jQuery("#appear_here_tag_row").show();
                            jQuery("#appear_here_archive_row").show();
                            jQuery("#appear_here_author_row").show();
                            jQuery("#appear_here_search_row").show();
                            jQuery("#appear_here_pages_row").show();
                            jQuery("#appear_here_article_row").show();
                        }
                        jQuery("[name=\"post[gc_message_box_appear_here]\"]").change(function() {
                            if (jQuery("#<?php echo $this->namespace; ?>appear_here_1:checked").val() === "1") {
                                jQuery("#appear_here_home_row").hide();
                                jQuery("#appear_here_category_row").hide();
                                jQuery("#appear_here_tag_row").hide();
                                jQuery("#appear_here_archive_row").hide();
                                jQuery("#appear_here_author_row").hide();
                                jQuery("#appear_here_search_row").hide();
                                jQuery("#appear_here_pages_row").hide();
                                jQuery("#appear_here_article_row").hide();
                            } else {
                                jQuery("#appear_here_home_row").show();
                                jQuery("#appear_here_category_row").show();
                                jQuery("#appear_here_tag_row").show();
                                jQuery("#appear_here_archive_row").show();
                                jQuery("#appear_here_author_row").show();
                                jQuery("#appear_here_search_row").show();
                                jQuery("#appear_here_pages_row").show();
                                jQuery("#appear_here_article_row").show();
                            }
                        });
                    },
                    shadows : function() {
                        
                        if (jQuery("#<?php echo $this->namespace; ?>text_shadow:checked").val() === "1") {
                            jQuery("#message_shadow_row").show();
                            jQuery("#button_shadow_row").show();
                            jQuery("#button_hover_shadow_row").show();
                        } else {
                            jQuery("#message_shadow_row").hide();
                            jQuery("#button_shadow_row").hide();
                            jQuery("#button_hover_shadow_row").hide();
                        }
                        jQuery("#<?php echo $this->namespace; ?>text_shadow").change(function() {
                            if (jQuery("#<?php echo $this->namespace; ?>text_shadow").is(':checked')) {
                                jQuery("#message_shadow_row").show();
                                jQuery("#button_shadow_row").show();
                                jQuery("#button_hover_shadow_row").show();
                            } else {
                                jQuery("#message_shadow_row").hide();
                                jQuery("#button_shadow_row").hide();
                                jQuery("#button_hover_shadow_row").hide();
                            }
                        });
                    },
                    changeColors : function (set) {
                        <?php 
                        $i=0;
                        foreach($colors as $key => $color) { ?>
                                jQuery('#<?php echo $color->get_name(); ?>').val(set['<?php echo strtolower($key); ?>']);
                                jQuery.farbtastic('#<?php echo $color->get_name(); ?>_cp').setColor(set['<?php echo strtolower($key); ?>']);
                        <?php } ?>
                            if(set['text_shadow'] === "1"){
                                jQuery("#<?php echo $this->namespace; ?>text_shadow").prop('checked', set['text_shadow']);
                            }
                            
                            console.log("message_shadow:"+set['message_shadow']);
                            jQuery("#message_shadow_row input").each(function() {

                                if (jQuery(this).val() == set['message_shadow'])
                                    jQuery(this).prop('checked', true);
                                else jQuery(this).prop('checked', false);
                            });
                            console.log("button_shadow:"+set['button_shadow']);
                            jQuery("#button_shadow_row input").each(function() {
                                if (jQuery(this).val() == set['button_shadow'])
                                    jQuery(this).prop('checked', true);
                                else jQuery(this).prop('checked', false);
                            });
                            console.log("button_hover_shadow:"+set['button_hover_shadow']);
                            jQuery("#button_hover_shadow_row input").each(function() {
                                if (jQuery(this).val() == set['button_hover_shadow'])
                                    jQuery(this).prop('checked', true);
                                else jQuery(this).prop('checked', false);
                            });
                            jQuery("#action_button_corner_radius_row input").each(function() {
                                jQuery(this).val(set['action_button_corner_radius'])
                            });
                            jQuery("#box_corner_radius_row input").each(function() {
                                jQuery(this).val(set['box_corner_radius'])
                            });
                            GC.MessageBox.shadows();
                    },
                    Appear : false,
                    Init : function () {
                        GC.MessageBox.colorPickerSetup();
                        GC.MessageBox.trigger();
                        GC.MessageBox.shadows();
                    }
                };

                jQuery(document).ready(function() {
                    GC.MessageBox.Init();
                });
            </script>
        <?php
        }

        protected function render_theme_selector() {
            ?>
                <select id="<?php echo $this->namespace; ?>predefined">
                    <option selected="selected" disabled="disabled" value="none"><?php echo __('Select a predefined set') ?></option>
                    <?php 
                    $themes = $this->themes_repo->get_all();
                    foreach ($themes as $id => $theme) : ?>
                        <option style="padding: 5px; color: <?php echo $theme->get_param('option_text_color'); ?>; font-weight: bold; background-color:<?php echo $theme->get_param('option_background_color'); ?>;" value="<?php echo $id;?>"><?php echo __($theme->get_name());  ?></option>
                    <?php endforeach; ?>
                </select>
            <?php
        }

        protected function render_js_theme_sets() {
            $themes = $this->themes_repo->get_all();
            $res = array();
            foreach ($themes as $id => $theme) {
                
                $options = $theme->get_options();
                $data = array();
                foreach ($options as $key => $value) {
                    $data[] = $key.":'".$value."'";
                }
                $res[] = $id .":{".implode(',',$data)."}".PHP_EOL;
            }
            echo implode(',',$res);
        }

        protected function render_js_current_theme() {
            $themes = $this->themes_repo->get_all();
            if(!count($themes)){
                return;
            }
            $theme = array_pop($themes);
            $res = array();
                
            $option_names = $theme->get_options();

            $data = array();
            foreach ($option_names as $key => $value) {
                $data[] = $key.":'".$this->options->get($key)->get_value()."'";
            }
            echo implode(',',$data).PHP_EOL;
        }

        protected function get_themes_count() {

        }

        protected function get_general_options() {
            return $this->options->filter_options_by_group("general");
        }

        protected function get_style_options() {
            return $this->options->filter_options_by_group("style");
        }

        protected function render_radio($option) {
            foreach($option->get_options() as $value => $text) :  ?>
            <div><input type="radio" <?php if($option->get_value() == $value) echo "checked"; ?> value="<?php echo $value;?>" name="post[<?php echo $option->get_name(); ?>]" id="<?php echo $option->get_name().'_'.$value; ?>" /><?php echo __($text) ?></div>
            <?php endforeach; 
        }

        protected function render_number_option($option) {
            ?>
                <input type="number" name="post[<?php echo $option->get_name(); ?>]" value="<?php echo $option->get_value(); ?>" min="0" />
            <?php
            $this->render_description($option->get_description());
        }

        protected function render_checkbox_option($option) {
            ?>
                <input <?php if($option->is_checked()) echo "checked=\"checked\""; ?> id="<?php echo $option->get_name(); ?>" type="checkbox" name="post[<?php echo $option->get_name(); ?>]" value="1" />
            <?php
        }

        protected function render_color_option($option) {
            ?>
                <input type="text" id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]" value="<?php echo $option->get_value(); ?>" />
                <div class="colorpickers" id="<?php echo $option->get_name($key); ?>_cp"></div>
            <?php
        }

        protected function render_text_area($option) {
            ?>
                <textarea id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]"><?php echo $option->get_value(); ?></textarea>
            <?php
            $this->render_description($option->get_description());
        }

        protected function render_text($option) {
            ?>
                <input type="text" id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]" value="<?php echo $option->get_value(); ?>" />
            <?php 
            $this->render_description($option->get_description());
        }

        protected function render_checkbox($option) {
            ?>
                <input <?php if($option->is_checked()) echo "checked=\"checked\""; ?> type="checkbox" id="<?php echo $option->get_name($key); ?>" name="post[<?php echo $option->get_name(); ?>]" value="1" />
            <?php
        }

        protected function render_select($option) {
            ?>
                <select id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]">
                    <?php foreach($option->get_options() as $value => $text) : ?>
                    <option <?php if($option->get_value() == $value) echo "selected=\"selected\""; ?> value="<?php echo $value;?>"><?php echo __($text) ?></option>
                    <?php endforeach; ?>
                </select>
            <?php
            $this->render_description($option->get_description());
        }

        protected function render_description($value) {
            ?>
                <div class="description"><?php echo $value; ?></div>
            <?php
        }

	}
}